import PlacesModel from "../../common/model/placesModel";
import getPlacesRepo from "../data/repository/GetPlacesRepo";
import IGetPlacesRepo from "../data/repository/IGetPlacesRepo";
import GettingPlacesUsecase from "../usecase/getPlaceUsecase";
import { IgetPlacesInfra } from "./protocols";

const getPlaces = ({
  httpHandler,
}: IgetPlacesInfra): (() => Promise<PlacesModel>) => {
  // get httpHandler
  const repository: IGetPlacesRepo = () => getPlacesRepo(httpHandler);
  // connet usecase and repository
  const usecase = new GettingPlacesUsecase(repository);
  // return method to use
  return () => usecase.execute();
};

export default getPlaces;
